#ifndef _DECL_marshall_H_
#define _DECL_marshall_H_
#include "charm++.h"
#ifdef CMK_CHECK_CRC
extern "C" void checkAllCRC(int);
#endif


/* DECLS: array marshallElt: ArrayElement{
marshallElt(CkMigrateMessage* impl_msg);
marshallElt(void);
void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d);
void flatRef(const flatStruct &s);
void pupped(const pupStruct &s);
void puppedSubclass(const pupStruct &s);
void PUPableReference(const CkReference<parent > &p);
void PUPablePointer(const CkPointer<parent > &p);
void simpleArray(int n, const int *arr);
void fancyArray(const int *arr2, int n, int m);
void crazyArray(const int *arr1, const int *arr2, int n);
void msgQ(int nMsgs, const msgQ_t &q);
void reflectMarshall(int forElt);
void done(void);
  initcall void eltInit(void);
};
 */
 class marshallElt;
 class CkIndex_marshallElt;
 class CProxy_marshallElt;
 class CProxyElement_marshallElt;
 class CProxySection_marshallElt;
/* --------------- index object ------------------ */
class CkIndex_marshallElt:public CProxyElement_ArrayElement{
  public:
    typedef marshallElt local_t;
    typedef CkIndex_marshallElt index_t;
    typedef CProxy_marshallElt proxy_t;
    typedef CProxyElement_marshallElt element_t;
    typedef CProxySection_marshallElt section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: marshallElt(CkMigrateMessage* impl_msg);
 */
    static int __idx_marshallElt_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_marshallElt_CkMigrateMessage; }
    static void _call_marshallElt_CkMigrateMessage(void* impl_msg,marshallElt* impl_obj);

/* DECLS: marshallElt(void);
 */
    static int __idx_marshallElt_void;
    static int ckNew(void) { return __idx_marshallElt_void; }
    static void _call_marshallElt_void(void* impl_msg,marshallElt* impl_obj);

/* DECLS: void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d);
 */
    static int __idx_basic_marshall2;
    static int basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d) { return __idx_basic_marshall2; }
    static void _call_basic_marshall2(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_basic_marshall2(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_basic_marshall2(PUP::er &p,void *msg);

/* DECLS: void flatRef(const flatStruct &s);
 */
    static int __idx_flatRef_marshall3;
    static int flatRef(const flatStruct &s) { return __idx_flatRef_marshall3; }
    static void _call_flatRef_marshall3(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_flatRef_marshall3(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_flatRef_marshall3(PUP::er &p,void *msg);

/* DECLS: void pupped(const pupStruct &s);
 */
    static int __idx_pupped_marshall4;
    static int pupped(const pupStruct &s) { return __idx_pupped_marshall4; }
    static void _call_pupped_marshall4(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_pupped_marshall4(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_pupped_marshall4(PUP::er &p,void *msg);

/* DECLS: void puppedSubclass(const pupStruct &s);
 */
    static int __idx_puppedSubclass_marshall5;
    static int puppedSubclass(const pupStruct &s) { return __idx_puppedSubclass_marshall5; }
    static void _call_puppedSubclass_marshall5(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_puppedSubclass_marshall5(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_puppedSubclass_marshall5(PUP::er &p,void *msg);

/* DECLS: void PUPableReference(const CkReference<parent > &p);
 */
    static int __idx_PUPableReference_marshall6;
    static int PUPableReference(const CkReference<parent > &p) { return __idx_PUPableReference_marshall6; }
    static void _call_PUPableReference_marshall6(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_PUPableReference_marshall6(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_PUPableReference_marshall6(PUP::er &p,void *msg);

/* DECLS: void PUPablePointer(const CkPointer<parent > &p);
 */
    static int __idx_PUPablePointer_marshall7;
    static int PUPablePointer(const CkPointer<parent > &p) { return __idx_PUPablePointer_marshall7; }
    static void _call_PUPablePointer_marshall7(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_PUPablePointer_marshall7(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_PUPablePointer_marshall7(PUP::er &p,void *msg);

/* DECLS: void simpleArray(int n, const int *arr);
 */
    static int __idx_simpleArray_marshall8;
    static int simpleArray(int n, const int *arr) { return __idx_simpleArray_marshall8; }
    static void _call_simpleArray_marshall8(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_simpleArray_marshall8(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_simpleArray_marshall8(PUP::er &p,void *msg);

/* DECLS: void fancyArray(const int *arr2, int n, int m);
 */
    static int __idx_fancyArray_marshall9;
    static int fancyArray(const int *arr2, int n, int m) { return __idx_fancyArray_marshall9; }
    static void _call_fancyArray_marshall9(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_fancyArray_marshall9(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_fancyArray_marshall9(PUP::er &p,void *msg);

/* DECLS: void crazyArray(const int *arr1, const int *arr2, int n);
 */
    static int __idx_crazyArray_marshall10;
    static int crazyArray(const int *arr1, const int *arr2, int n) { return __idx_crazyArray_marshall10; }
    static void _call_crazyArray_marshall10(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_crazyArray_marshall10(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_crazyArray_marshall10(PUP::er &p,void *msg);

/* DECLS: void msgQ(int nMsgs, const msgQ_t &q);
 */
    static int __idx_msgQ_marshall11;
    static int msgQ(int nMsgs, const msgQ_t &q) { return __idx_msgQ_marshall11; }
    static void _call_msgQ_marshall11(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_msgQ_marshall11(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_msgQ_marshall11(PUP::er &p,void *msg);

/* DECLS: void reflectMarshall(int forElt);
 */
    static int __idx_reflectMarshall_marshall12;
    static int reflectMarshall(int forElt) { return __idx_reflectMarshall_marshall12; }
    static void _call_reflectMarshall_marshall12(void* impl_msg,marshallElt* impl_obj);
    static int _callmarshall_reflectMarshall_marshall12(char* impl_buf,marshallElt* impl_obj);
    static void _marshallmessagepup_reflectMarshall_marshall12(PUP::er &p,void *msg);

/* DECLS: void done(void);
 */
    static int __idx_done_void;
    static int done(void) { return __idx_done_void; }
    static void _call_done_void(void* impl_msg,marshallElt* impl_obj);

};
/* --------------- element proxy ------------------ */
 class CProxyElement_marshallElt : public CProxyElement_ArrayElement{
  public:
    typedef marshallElt local_t;
    typedef CkIndex_marshallElt index_t;
    typedef CProxy_marshallElt proxy_t;
    typedef CProxyElement_marshallElt element_t;
    typedef CProxySection_marshallElt section_t;

    CProxyElement_marshallElt(void) {}
    CProxyElement_marshallElt(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    marshallElt *ckLocal(void) const
      { return (marshallElt *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_marshallElt(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_marshallElt(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: marshallElt(CkMigrateMessage* impl_msg);
 */

/* DECLS: marshallElt(void);
 */
    void insert(int onPE=-1);
/* DECLS: void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d);
 */
    void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void flatRef(const flatStruct &s);
 */
    void flatRef(const flatStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void pupped(const pupStruct &s);
 */
    void pupped(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void puppedSubclass(const pupStruct &s);
 */
    void puppedSubclass(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPableReference(const CkReference<parent > &p);
 */
    void PUPableReference(const CkReference<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPablePointer(const CkPointer<parent > &p);
 */
    void PUPablePointer(const CkPointer<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void simpleArray(int n, const int *arr);
 */
    void simpleArray(int n, const int *arr, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void fancyArray(const int *arr2, int n, int m);
 */
    void fancyArray(const int *arr2, int n, int m, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void crazyArray(const int *arr1, const int *arr2, int n);
 */
    void crazyArray(const int *arr1, const int *arr2, int n, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void msgQ(int nMsgs, const msgQ_t &q);
 */
    void msgQ(int nMsgs, const msgQ_t &q, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void reflectMarshall(int forElt);
 */
    void reflectMarshall(int forElt, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void done(void);
 */
    void done(void) ;

};
PUPmarshall(CProxyElement_marshallElt);
/* ---------------- collective proxy -------------- */
 class CProxy_marshallElt : public CProxy_ArrayElement{
  public:
    typedef marshallElt local_t;
    typedef CkIndex_marshallElt index_t;
    typedef CProxy_marshallElt proxy_t;
    typedef CProxyElement_marshallElt element_t;
    typedef CProxySection_marshallElt section_t;

    CProxy_marshallElt(void) {}
    CProxy_marshallElt(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_marshallElt operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_marshallElt(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_marshallElt(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator [] (int idx) const 
        {return CProxyElement_marshallElt(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator () (int idx) const 
        {return CProxyElement_marshallElt(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_marshallElt(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_marshallElt(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: marshallElt(CkMigrateMessage* impl_msg);
 */

/* DECLS: marshallElt(void);
 */
    static CkArrayID ckNew(const CkArrayOptions &opts);
    static CkArrayID ckNew(const int s1);

/* DECLS: void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d);
 */
    void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void flatRef(const flatStruct &s);
 */
    void flatRef(const flatStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void pupped(const pupStruct &s);
 */
    void pupped(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void puppedSubclass(const pupStruct &s);
 */
    void puppedSubclass(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPableReference(const CkReference<parent > &p);
 */
    void PUPableReference(const CkReference<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPablePointer(const CkPointer<parent > &p);
 */
    void PUPablePointer(const CkPointer<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void simpleArray(int n, const int *arr);
 */
    void simpleArray(int n, const int *arr, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void fancyArray(const int *arr2, int n, int m);
 */
    void fancyArray(const int *arr2, int n, int m, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void crazyArray(const int *arr1, const int *arr2, int n);
 */
    void crazyArray(const int *arr1, const int *arr2, int n, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void msgQ(int nMsgs, const msgQ_t &q);
 */
    void msgQ(int nMsgs, const msgQ_t &q, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void reflectMarshall(int forElt);
 */
    void reflectMarshall(int forElt, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void done(void);
 */
    void done(void) ;

};
PUPmarshall(CProxy_marshallElt);
/* ---------------- section proxy -------------- */
 class CProxySection_marshallElt : public CProxySection_ArrayElement{
  public:
    typedef marshallElt local_t;
    typedef CkIndex_marshallElt index_t;
    typedef CProxy_marshallElt proxy_t;
    typedef CProxyElement_marshallElt element_t;
    typedef CProxySection_marshallElt section_t;

    CProxySection_marshallElt(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_marshallElt operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_marshallElt(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_marshallElt(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator [] (int idx) const 
        {return CProxyElement_marshallElt(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_marshallElt operator () (int idx) const 
        {return CProxyElement_marshallElt(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_marshallElt(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_marshallElt(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_marshallElt(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: marshallElt(CkMigrateMessage* impl_msg);
 */

/* DECLS: marshallElt(void);
 */

/* DECLS: void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d);
 */
    void basic(unsigned char b, char c, short i, unsigned short j, int k, unsigned int l, long m, unsigned long n, float f, double d, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void flatRef(const flatStruct &s);
 */
    void flatRef(const flatStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void pupped(const pupStruct &s);
 */
    void pupped(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void puppedSubclass(const pupStruct &s);
 */
    void puppedSubclass(const pupStruct &s, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPableReference(const CkReference<parent > &p);
 */
    void PUPableReference(const CkReference<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void PUPablePointer(const CkPointer<parent > &p);
 */
    void PUPablePointer(const CkPointer<parent > &p, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void simpleArray(int n, const int *arr);
 */
    void simpleArray(int n, const int *arr, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void fancyArray(const int *arr2, int n, int m);
 */
    void fancyArray(const int *arr2, int n, int m, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void crazyArray(const int *arr1, const int *arr2, int n);
 */
    void crazyArray(const int *arr1, const int *arr2, int n, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void msgQ(int nMsgs, const msgQ_t &q);
 */
    void msgQ(int nMsgs, const msgQ_t &q, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void reflectMarshall(int forElt);
 */
    void reflectMarshall(int forElt, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void done(void);
 */
    void done(void) ;

};
PUPmarshall(CProxySection_marshallElt);
typedef CBaseT<ArrayElementT<CkIndex1D>,CProxy_marshallElt>  CBase_marshallElt;

extern void _registermarshall(void);
#endif
