
/* DEFS: message threadCollisions{
Collision colls[];
}
;
 */
#ifndef CK_TEMPLATES_ONLY
void *CMessage_threadCollisions::operator new(size_t s){
  return threadCollisions::alloc(__idx, s, 0, 0);
}
void *CMessage_threadCollisions::operator new(size_t s, int* sz){
  return threadCollisions::alloc(__idx, s, sz, 0);
}
void *CMessage_threadCollisions::operator new(size_t s, int* sz,const int pb){
  return threadCollisions::alloc(__idx, s, sz, pb);
}
void *CMessage_threadCollisions::operator new(size_t s, int sz0) {
  int sizes[1];
  sizes[0] = sz0;
  return threadCollisions::alloc(__idx, s, sizes, 0);
}
void *CMessage_threadCollisions::operator new(size_t s, int sz0, const int p) {
  int sizes[1];
  sizes[0] = sz0;
  return threadCollisions::alloc(__idx, s, sizes, p);
}
void* CMessage_threadCollisions::alloc(int msgnum, size_t sz, int *sizes, int pb) {
  int offsets[2];
  offsets[0] = ALIGN8(sz);
  if(sizes==0)
    offsets[1] = offsets[0];
  else
    offsets[1] = offsets[0] + ALIGN8(sizeof(Collision)*sizes[0]);
  threadCollisions *newmsg = (threadCollisions *) CkAllocMsg(msgnum, offsets[1], pb);
  newmsg->colls = (Collision *) ((char *)newmsg + offsets[0]);
  return (void *) newmsg;
}
void* CMessage_threadCollisions::pack(threadCollisions *msg) {
  msg->colls = (Collision *) ((char *)msg->colls - (char *)msg);
  return (void *) msg;
}
threadCollisions* CMessage_threadCollisions::unpack(void* buf) {
  threadCollisions *msg = (threadCollisions *) buf;
  msg->colls = (Collision *) ((size_t)msg->colls + (char *)msg);
  return msg;
}
int CMessage_threadCollisions::__idx=0;
#endif

/* DEFS: group threadCollideMgr: collideClient{
threadCollideMgr(void);
void sendRemote(CkReductionMsg* impl_msg);
void remoteCollisions(threadCollisions* impl_msg);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_threadCollideMgr::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: threadCollideMgr(void);
 */

/* DEFS: void sendRemote(CkReductionMsg* impl_msg);
 */
void CProxyElement_threadCollideMgr::sendRemote(CkReductionMsg* impl_msg)
{
  ckCheck();
  if (ckIsDelegated()) {
     CkGroupMsgPrep(CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupID());
     ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
  } else CkSendMsgBranch(CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
}

/* DEFS: void remoteCollisions(threadCollisions* impl_msg);
 */
void CProxyElement_threadCollideMgr::remoteCollisions(threadCollisions* impl_msg)
{
  ckCheck();
  if (ckIsDelegated()) {
     CkGroupMsgPrep(CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupID());
     ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupPe(), ckGetGroupID());
  } else CkSendMsgBranch(CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
}
/* DEFS: threadCollideMgr(void);
 */
CkGroupID CProxy_threadCollideMgr::ckNew(void)
{
  void *impl_msg = CkAllocSysMsg();
  return CkCreateGroup(CkIndex_threadCollideMgr::__idx, CkIndex_threadCollideMgr::__idx_threadCollideMgr_void, impl_msg);
}
 int CkIndex_threadCollideMgr::__idx_threadCollideMgr_void=0;
void CkIndex_threadCollideMgr::_call_threadCollideMgr_void(void* impl_msg,threadCollideMgr * impl_obj)
{
  CkFreeSysMsg(impl_msg);
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) threadCollideMgr();
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}

/* DEFS: void sendRemote(CkReductionMsg* impl_msg);
 */
void CProxy_threadCollideMgr::sendRemote(CkReductionMsg* impl_msg)
{
  ckCheck();
  if (ckIsDelegated()) {
     CkGroupMsgPrep(CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupID());
     ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupID());
  } else CkBroadcastMsgBranch(CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, ckGetGroupID(),0);
}
    void CProxy_threadCollideMgr::sendRemote(CkReductionMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg, impl_msg, npes, pes, ckGetGroupID(),0);
    }
 int CkIndex_threadCollideMgr::__idx_sendRemote_CkReductionMsg=0;
void CkIndex_threadCollideMgr::_call_sendRemote_CkReductionMsg(void* impl_msg,threadCollideMgr * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->sendRemote((CkReductionMsg*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}

/* DEFS: void remoteCollisions(threadCollisions* impl_msg);
 */
void CProxy_threadCollideMgr::remoteCollisions(threadCollisions* impl_msg)
{
  ckCheck();
  if (ckIsDelegated()) {
     CkGroupMsgPrep(CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupID());
     ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupID());
  } else CkBroadcastMsgBranch(CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, ckGetGroupID(),0);
}
    void CProxy_threadCollideMgr::remoteCollisions(threadCollisions* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions, impl_msg, npes, pes, ckGetGroupID(),0);
    }
 int CkIndex_threadCollideMgr::__idx_remoteCollisions_threadCollisions=0;
void CkIndex_threadCollideMgr::_call_remoteCollisions_threadCollisions(void* impl_msg,threadCollideMgr * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->remoteCollisions((threadCollisions*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}
#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_threadCollideMgr::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size);
  CkRegisterBase(__idx, CkIndex_collideClient::__idx);
   CkRegisterGroupIrr(__idx,threadCollideMgr::isIrreducible());
// REG: threadCollideMgr(void);
  __idx_threadCollideMgr_void = CkRegisterEp("threadCollideMgr(void)",
     (CkCallFnPtr)_call_threadCollideMgr_void, 0, __idx, 0);
  CkRegisterDefaultCtor(__idx, __idx_threadCollideMgr_void);

// REG: void sendRemote(CkReductionMsg* impl_msg);
  __idx_sendRemote_CkReductionMsg = CkRegisterEp("sendRemote(CkReductionMsg* impl_msg)",
     (CkCallFnPtr)_call_sendRemote_CkReductionMsg, CMessage_CkReductionMsg::__idx, __idx, 0);

// REG: void remoteCollisions(threadCollisions* impl_msg);
  __idx_remoteCollisions_threadCollisions = CkRegisterEp("remoteCollisions(threadCollisions* impl_msg)",
     (CkCallFnPtr)_call_remoteCollisions_threadCollisions, CMessage_threadCollisions::__idx, __idx, 0);
}
#endif

/* DEFS: array threadCollide: ArrayElement{
threadCollide(CkMigrateMessage* impl_msg);
threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
void resultsDone(void);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_threadCollide::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: threadCollide(CkMigrateMessage* impl_msg);
 */

/* DEFS: threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
 */
void CProxyElement_threadCollide::insert(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr, int onPE, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
  }
   ckInsert((CkArrayMessage *)impl_msg,CkIndex_threadCollide::__idx_threadCollide_marshall1,onPE);
}

/* DEFS: void resultsDone(void);
 */
void CProxyElement_threadCollide::resultsDone(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_threadCollide::__idx_resultsDone_void,0);
}
/* DEFS: threadCollide(CkMigrateMessage* impl_msg);
 */
 int CkIndex_threadCollide::__idx_threadCollide_CkMigrateMessage=0;
void CkIndex_threadCollide::_call_threadCollide_CkMigrateMessage(void* impl_msg,threadCollide * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) threadCollide((CkMigrateMessage*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}

/* DEFS: threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
 */
CkArrayID CProxy_threadCollide::ckNew(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr, const CkArrayOptions &opts, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
  }
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_threadCollide::__idx_threadCollide_marshall1,opts);
}
CkArrayID CProxy_threadCollide::ckNew(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr, const int s1, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_TCharm &)threads;
    //Have to cast away const-ness to get pup routine
    implP|(CProxy_threadCollideMgr &)tmgr;
    //Have to cast away const-ness to get pup routine
    implP|(CollideHandle &)cmgr;
  }
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_threadCollide::__idx_threadCollide_marshall1,CkArrayOptions(s1));
}
 int CkIndex_threadCollide::__idx_threadCollide_marshall1=0;
void CkIndex_threadCollide::_call_threadCollide_marshall1(void* impl_msg,threadCollide * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr*/
  PUP::fromMem implP(impl_buf);
  CProxy_TCharm threads; implP|threads;
  CProxy_threadCollideMgr tmgr; implP|tmgr;
  CollideHandle cmgr; implP|cmgr;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) threadCollide(threads, tmgr, cmgr);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}
int CkIndex_threadCollide::_callmarshall_threadCollide_marshall1(char* impl_buf,threadCollide * impl_obj) {
  /*Unmarshall pup'd fields: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr*/
  PUP::fromMem implP(impl_buf);
  CProxy_TCharm threads; implP|threads;
  CProxy_threadCollideMgr tmgr; implP|tmgr;
  CollideHandle cmgr; implP|cmgr;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) threadCollide(threads, tmgr, cmgr);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
  return implP.size();
}
void CkIndex_threadCollide::_marshallmessagepup_threadCollide_marshall1(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr*/
  PUP::fromMem implP(impl_buf);
  CProxy_TCharm threads; implP|threads;
  CProxy_threadCollideMgr tmgr; implP|tmgr;
  CollideHandle cmgr; implP|cmgr;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("threads");
  implDestP|threads;
  if (implDestP.hasComments()) implDestP.comment("tmgr");
  implDestP|tmgr;
  if (implDestP.hasComments()) implDestP.comment("cmgr");
  implDestP|cmgr;
}

/* DEFS: void resultsDone(void);
 */
void CProxy_threadCollide::resultsDone(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_threadCollide::__idx_resultsDone_void,0);
}
 int CkIndex_threadCollide::__idx_resultsDone_void=0;
void CkIndex_threadCollide::_call_resultsDone_void(void* impl_msg,threadCollide * impl_obj)
{
  CkFreeSysMsg(impl_msg);
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  int alreadyUserCode = 1;
  setMemoryStatus(alreadyUserCode);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->resultsDone();
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(alreadyUserCode);
#endif
}
/* DEFS: threadCollide(CkMigrateMessage* impl_msg);
 */

/* DEFS: threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
 */

/* DEFS: void resultsDone(void);
 */
void CProxySection_threadCollide::resultsDone(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_threadCollide::__idx_resultsDone_void,0);
}
#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_threadCollide::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size);
  CkRegisterBase(__idx, CkIndex_ArrayElement::__idx);
// REG: threadCollide(CkMigrateMessage* impl_msg);
  __idx_threadCollide_CkMigrateMessage = CkRegisterEp("threadCollide(CkMigrateMessage* impl_msg)",
     (CkCallFnPtr)_call_threadCollide_CkMigrateMessage, 0, __idx, 0);
  CkRegisterMigCtor(__idx, __idx_threadCollide_CkMigrateMessage);

// REG: threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
  __idx_threadCollide_marshall1 = CkRegisterEp("threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr)",
     (CkCallFnPtr)_call_threadCollide_marshall1, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_threadCollide_marshall1,(CkMarshallUnpackFn)_callmarshall_threadCollide_marshall1);
  CkRegisterMessagePupFn(__idx_threadCollide_marshall1,(CkMessagePupFn)_marshallmessagepup_threadCollide_marshall1);

// REG: void resultsDone(void);
  __idx_resultsDone_void = CkRegisterEp("resultsDone(void)",
     (CkCallFnPtr)_call_resultsDone_void, 0, __idx, 0);
}
#endif

#ifndef CK_TEMPLATES_ONLY
void _registercollide(void)
{
  static int _done = 0; if(_done) return; _done = 1;
      _registercollidecharm();

/* REG: message threadCollisions{
Collision colls[];
}
;
*/
CMessage_threadCollisions::__register("threadCollisions", sizeof(threadCollisions),(CkPackFnPtr) threadCollisions::pack,(CkUnpackFnPtr) threadCollisions::unpack);

/* REG: group threadCollideMgr: collideClient{
threadCollideMgr(void);
void sendRemote(CkReductionMsg* impl_msg);
void remoteCollisions(threadCollisions* impl_msg);
};
*/
  CkIndex_threadCollideMgr::__register("threadCollideMgr", sizeof(threadCollideMgr));

/* REG: array threadCollide: ArrayElement{
threadCollide(CkMigrateMessage* impl_msg);
threadCollide(const CProxy_TCharm &threads, const CProxy_threadCollideMgr &tmgr, const CollideHandle &cmgr);
void resultsDone(void);
};
*/
  CkIndex_threadCollide::__register("threadCollide", sizeof(threadCollide));

}
#endif
